package com.hive.sample

import com.hive.Analytics
import java.util.*


/**
 * Created by Hive Analytics Log System
 *
 * @author ryuvsken
 */
object AnalyticsLogAPI {


    /**
     * 게임 가입 로그
     *
     * @param userId        사용자 ID
     * @param nickname        사용자 닉네임
     */
    fun Account_Join(userId: String, nickname: String) {

        val logData = HashMap<String, Any>()
        logData["category"] = "sdk_test_join" // 가입
        logData["userid"] = userId
        logData["nickname"] = nickname
        Analytics.sendAnalyticsLog(logData)
    }


    /**
     * 게임 로그인 로그
     *
     * @param userId        사용자 ID
     * @param currentGold    현재 보유 골드
     */
    fun Account_Login(nickname: String, currentGold: Long) {

        val logData = HashMap<String, Any>()
        logData["category"] = "sdk_test_login"    // 로그인
        logData["nickname"] = nickname
        logData["current_gold"] = currentGold
        Analytics.sendAnalyticsLog(logData)
    }


    /**
     * 계정 레벨업 로그
     *
     * @param level            현재(상승된) 레벨
     */
    fun Account_LevelUp(level: Int) {

        val logData = HashMap<String, Any>()
        logData["category"] = "hivesdk_levelup_log"
        logData["level"] = level
        Analytics.sendAnalyticsLog(logData)
    }


    /**
     * 캐릭터 뽑기 로그
     *
     * @param character
     */
    fun Account_CharacterGet(character: String) {

        val logData = HashMap<String, Any>()
        logData["category"] = "hivesdk_character_get_log"
        logData["character"] = character
        Analytics.sendAnalyticsLog(logData)
    }

    //Example Sandbox Server HIVE SDK Log Test
    fun log_hivesdk_singular_normal_test(
//	      int amountCurr,
//        int characterTypeId,
//        int characterId,
//        int accountLevel,
//        int assetId,
//        String itemName,
//        int amountVar,
//        int amountPrev,
//        int actionId,
//        int accountId,
//        String actionName,
//        String assetName,
//        int itemId,
//        int channelUid,
//        int characterLevel,
//        String extraLogBoby,
//        int amount_free_prev,
//        int amount_free_var,
//        int amount_free_curr,
//        int amount_paid_prev,
//        int amount_paid_var,
//        int amount_paid_curr,
//        int account_id,
//        int deviceid,
//        int isEmulator
    ) {

        val logData = java.util.HashMap<String, Any>()
        logData["category"] = "hivesdk_asset_var_log"
        logData["amountCurr"] = 2
        logData["characterTypeId"] = 0
        logData["characterId"] = 4
        logData["accountLevel"] = 3
        logData["assetId"] = 21
        logData["itemName"] = "item00000000000000000000000000"
        logData["amountVar"] = 4
        logData["amountPrev"] = 3
        logData["actionId"] = 5
        logData["accountId"] = 13491024
        logData["actionName"] = "WAROFCLOUD"
        logData["assetName"] = "PVPOPOWERWPOWEPRWER"
        logData["itemId"] = 3398012
        logData["channelUid"] = 4809012
        logData["characterLevel"] = 8403
        logData["extraLogBoby"] = "{'category','hivetest', 'level':10}"
        logData["amount_free_prev"] = 1
        logData["amount_free_var"] = 1
        logData["amount_free_curr"] = 1
        logData["amount_paid_prev"] = 1
        logData["amount_paid_var"] = 1
        logData["amount_paid_curr"] = 1
        logData["account_id"] = 1
        logData["deviceid"] = 2
        logData["isEmulator"] = 0


        Analytics.sendAnalyticsLog(logData)
    }


}
