package com.hive.sample

import android.app.Activity
import android.os.Handler
import android.text.TextUtils
import android.util.Log
import android.view.View
import android.widget.*
import com.com2us.hivesdk.normal.freefull.google.global.android.common.R
import com.gcp.hiveprotocol.UrlManager
import com.hive.Analytics
import com.hive.AuthV4
import com.hive.Configuration
import com.hive.base.Property
import com.hive.sample.uihelper.ViewPagerBase
import org.json.JSONArray
import org.json.JSONException
import org.json.JSONObject
import java.util.*


/**
 * HIVE SDK 의 Analytics 기능 테스트 뷰
 */
class AnalyticsTestView(activity: Activity, view: View, title: String) : ViewPagerBase(activity, view, title), View.OnClickListener {

    private var mapSwitchUI: MutableMap<com.hive.Analytics.TrackingType, Spinner>? = null

    private var mYourLevel = 1
    private val mYourCharacter = ArrayList<String>()

    private var bAnalyticsSend: Boolean = false
    // Initialize a new instance of Handler
    internal var mHandler = Handler()
    internal var mThread: Thread? = null
    private val runnableCode1 = Runnable {
        try {

            while (true) {

                for (i in 0..9) {
                    AnalyticsLogAPI.log_hivesdk_singular_normal_test()
                }
                Thread.sleep(100)
            }
        } catch (e: InterruptedException) {
            e.printStackTrace()
        }
    }
    private val runnableCode2 = Runnable {
        try {

            while (true) {
                for (i in 0..9) {
                    Log.w("IT'sTEST", "TEST LOG PRINT@@@@@@@@@@@@@@")
                }
                //			mHandler.postDelayed(this, 100);
                Thread.sleep(100)
            }
        } catch (e: InterruptedException) {
            e.printStackTrace()
        }
    }

    init {

        initUi()
    }

    private fun applyTrackerStatusToUI() {
        // Configuration 정보가 로딩되어 있어야 함.
        // set On by configuration values
//        val arrayTrackers = com.hive.Configuration.trackers

        val arrayTrackers = ArrayList<com.hive.Analytics.Tracker>()
        val trackerArray = Configuration.trackers
        var trackerObject: JSONObject?
        for (i in 0 until trackerArray.length()) {
            trackerObject = trackerArray.optJSONObject(i)
            if (trackerObject == null) {
                continue
            }
            val trackerName = trackerObject!!.optString("@name", null)
            try {
                val tracker = Analytics.Tracker(Analytics.TrackingType.valueOf(trackerName.toUpperCase(Locale.US)), trackerName, "", "")
                arrayTrackers.add(tracker)
            } catch (e: Exception) {
                continue
            }
        }

        for (tracker in arrayTrackers) {
            if (mapSwitchUI!![tracker.trackingType] != null) {

                mapSwitchUI!![tracker.trackingType]!!.setSelection(0)
                Analytics.setEnableTracker(tracker.trackingType, true)
            }
        }
    }

    private fun initUi() {

        createLogView(R.id.logview, R.id.btnLogDialog, R.id.btnLogClear)

        val tvYourLevel = this.view.findViewById<View>(R.id.tvYourLevel) as TextView
        val btnLevelUp = this.view.findViewById<View>(R.id.btnLevelUp) as Button
        btnLevelUp.setOnClickListener(this)
        tvYourLevel.text = mYourLevel.toString()

        val tvYourCharacter = this.view.findViewById<View>(R.id.tvYourCharacter) as TextView
        val btnChooseCharacter = this.view.findViewById<View>(R.id.btnChooseCharacter) as Button
        btnChooseCharacter.setOnClickListener(this)
        tvYourCharacter.text = mYourCharacter.toString()

        var spAdapter: ArrayAdapter<CharSequence>

        // Mobile App Tracker on/off
        mapSwitchUI = HashMap()

        spAdapter = ArrayAdapter(activity, android.R.layout.simple_spinner_item)
        spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        spAdapter.add("On")
        spAdapter.add("Off")
        (this.view.findViewById<View>(R.id.spAdjust) as Spinner).adapter = spAdapter
        (this.view.findViewById<View>(R.id.spAdjust) as Spinner).setSelection(1)
        mapSwitchUI!![Analytics.TrackingType.ADJUST] = this.view.findViewById<View>(R.id.spAdjust) as Spinner

        spAdapter = ArrayAdapter(activity, android.R.layout.simple_spinner_item)
        spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        spAdapter.add("On")
        spAdapter.add("Off")
        (this.view.findViewById<View>(R.id.spSingular) as Spinner).adapter = spAdapter
        (this.view.findViewById<View>(R.id.spSingular) as Spinner).setSelection(1)
        mapSwitchUI!![Analytics.TrackingType.SINGULAR] = this.view.findViewById<View>(R.id.spSingular) as Spinner

        spAdapter = ArrayAdapter(activity, android.R.layout.simple_spinner_item)
        spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        spAdapter.add("On")
        spAdapter.add("Off")
        (this.view.findViewById<View>(R.id.spAppsFlyer) as Spinner).adapter = spAdapter
        (this.view.findViewById<View>(R.id.spAppsFlyer) as Spinner).setSelection(1)
        mapSwitchUI!![Analytics.TrackingType.APPSFLYER] = this.view.findViewById<View>(R.id.spAppsFlyer) as Spinner

        // Mobile App Tracking Event
        spAdapter = ArrayAdapter(activity, android.R.layout.simple_spinner_item)
        spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        spAdapter.add("Install")
        spAdapter.add("Update")
        spAdapter.add("Open")
        spAdapter.add("TutorialComplete")

        (this.view.findViewById<View>(R.id.spMATEvent) as Spinner).adapter = spAdapter
        (this.view.findViewById<View>(R.id.spMATEvent) as Spinner).setSelection(spAdapter.count - 1)

        this.view.findViewById<View>(R.id.btnSendMATEvent).setOnClickListener(this)

        // Analytics Log Category1
        spAdapter = ArrayAdapter(activity, android.R.layout.simple_spinner_item)
        spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        spAdapter.add("sdk_test_join")
        spAdapter.add("sdk_test_login")

        (this.view.findViewById<View>(R.id.spLogCategory1) as Spinner).adapter = spAdapter

        (this.view.findViewById<View>(R.id.edtAnalyticsLogServer) as EditText).setText(UrlManager.Analytics.getServer())
        this.view.findViewById<View>(R.id.btnSendAnalyticsLog).setOnClickListener(this)
        this.view.findViewById<View>(R.id.btnSendAnalyticsLogStart).setOnClickListener(this)
        this.view.findViewById<View>(R.id.btnSendAnalyticsLogStop).setOnClickListener(this)
        bAnalyticsSend = false
    }


    override fun onUpdateView() {
        // 테스트 화면으로 올 때마다 설정데이터 기반으로 UI 업데이
        applyTrackerStatusToUI()



        updateLevelAndCharacter()
    }


    private fun updateLevelAndCharacter() {

        val playerInfo = AuthV4.getPlayerInfo()

        val p = Property.INSTANCE

        val tvYourLevel = this.view.findViewById<View>(R.id.tvYourLevel) as TextView
        val btnLevelUp = this.view.findViewById<View>(R.id.btnLevelUp) as Button

        val tvYourCharacter = this.view.findViewById<View>(R.id.tvYourCharacter) as TextView
        val btnChooseCharacter = this.view.findViewById<View>(R.id.btnChooseCharacter) as Button

        if (playerInfo != null) {
            if (!TextUtils.isEmpty(playerInfo.playerId.toString())) {

                var strMyLevel = p.getValue("sample.myLevel ${playerInfo.playerId}", "")
                // 저장되어 있지 않으면 초기 실행으로 판단하여 기본값으로 세팅 및 로그 전송함.
                if (TextUtils.isEmpty(strMyLevel)) {
                    strMyLevel = mYourLevel.toString()
                    p.setValue("sample.myLevel ${playerInfo.playerId}", strMyLevel)
                    p.writeProperties()
                    AnalyticsLogAPI.Account_LevelUp(Integer.valueOf(strMyLevel))
                }
                mYourLevel = Integer.valueOf(strMyLevel)


                val strCharacters = p.getValue("sample.myCharacters ${playerInfo.playerId}", mYourCharacter.toString())
                try {
                    if (!TextUtils.isEmpty(strCharacters)) {
                        val jsonCharacterArray = JSONArray(strCharacters)
                        mYourCharacter.clear()
                        for (i in 0..8) {
                            val character = jsonCharacterArray.optString(i)
                            if (!TextUtils.isEmpty(character)) {
                                mYourCharacter.add(character)
                            }
                        }
                    }
                } catch (e: Exception) {
                    e.printStackTrace()
                }

            }
        }

        tvYourLevel.text = mYourLevel.toString()
        tvYourCharacter.text = mYourCharacter.toString()
    }

    override fun onClick(v: View) {

        val rid = v.id

        when (rid) {

            R.id.btnLevelUp -> {

                val playerInfo = AuthV4.getPlayerInfo()

                if (playerInfo != null) {
                    if (!TextUtils.isEmpty(playerInfo.playerId.toString())) {

                        Toast.makeText(this.view.context, "Level Up!!", Toast.LENGTH_SHORT).show()

                        mYourLevel++

                        val p = Property.INSTANCE
                        p.setValue("sample.myLevel ${playerInfo.playerId}", mYourLevel.toString())
                        p.writeProperties()
                        AnalyticsLogAPI.Account_LevelUp(mYourLevel)
                    } else {

                        Toast.makeText(this.view.context, "Login First.", Toast.LENGTH_SHORT).show()
                    }
                }
                updateLevelAndCharacter()
            }


            R.id.btnChooseCharacter -> {

                val playerInfo = AuthV4.getPlayerInfo()

                if (playerInfo != null) {
                    if (!TextUtils.isEmpty(playerInfo.playerId.toString())) {

                        if (mYourCharacter.size >= 5) {

                            Toast.makeText(this.view.context, "Character Limit(5 per account) Excceeded.", Toast.LENGTH_SHORT).show()

                        } else {

                            Toast.makeText(this.view.context, "Choose Character!!", Toast.LENGTH_SHORT).show()

                            val newCharacter = chooseCharacter(mYourCharacter)
                            mYourCharacter.add(newCharacter)

                            val p = Property.INSTANCE
                            val obj = JSONArray()

                            try {
                                for (i in mYourCharacter.indices) {
                                    obj.put(i, mYourCharacter[i])
                                }
                            } catch (e: JSONException) {
                                e.printStackTrace()
                            }

                            p.setValue("sample.myCharacters ${playerInfo.playerId}", obj.toString())
                            p.writeProperties()
                            AnalyticsLogAPI.Account_CharacterGet(newCharacter)
                        }
                    } else {

                        Toast.makeText(this.view.context, "Login First.", Toast.LENGTH_SHORT).show()
                    }
                }
                updateLevelAndCharacter()
            }

            // Mobile App Tracking (3rd-party) Test
            R.id.btnSendMATEvent -> {
                // on/off 적용.
                run {
                    var spinner = this.view.findViewById<View>(R.id.spAdjust) as Spinner
                    var selectedValue = spinner.adapter.getItem(spinner.selectedItemPosition) as String
                    Analytics.setEnableTracker(Analytics.TrackingType.ADJUST, selectedValue == "On")


                    spinner = this.view.findViewById<View>(R.id.spSingular) as Spinner
                    selectedValue = spinner.adapter.getItem(spinner.selectedItemPosition) as String
                    Analytics.setEnableTracker(Analytics.TrackingType.SINGULAR, selectedValue == "On")

                    spinner = this.view.findViewById<View>(R.id.spAppsFlyer) as Spinner
                    selectedValue = spinner.adapter.getItem(spinner.selectedItemPosition) as String
                    Analytics.setEnableTracker(Analytics.TrackingType.APPSFLYER, selectedValue == "On")
                }

                val spinner = this.view.findViewById<View>(R.id.spMATEvent) as Spinner
                val selectedValue = spinner.adapter.getItem(spinner.selectedItemPosition) as String

                addLog("\n\n=== 서드파티 이벤트 전송 테스트 ===\n")
                addLog("Analytics.sendEvent($selectedValue) Called\n")

                Analytics.sendEvent(selectedValue)
            }


            // Hive Analytics Log System Test
            R.id.btnSendAnalyticsLog -> {

                val spinner: Spinner

                spinner = this.view.findViewById<View>(R.id.spLogCategory1) as Spinner
                val logCategory1 = spinner.selectedItemPosition

                addLog("\n\n=== 앱과 사용자 분석용 Log 전송 테스트 ===\n")

                // 계정
                if (logCategory1 == 0) {

                    // 가입
                    addLog("Analytics.sendAnalyticsLog() Called by AnalyticsLogAPI.Account_Join()\n")

                    AnalyticsLogAPI.Account_Join("user001", "바람돌이")
                } else {

                    addLog("Analytics.sendAnalyticsLog() Called by AnalyticsLogAPI.Account_Login()\n")

                    AnalyticsLogAPI.Account_Login("user001", 1000000)    // 로그인 시 보유 Gold
                }// 로그인
            }
            R.id.btnSendAnalyticsLogStart -> {
                if (bAnalyticsSend == false) {


                    bAnalyticsSend = true
                    val spinner: Spinner
                    spinner = this.view.findViewById<View>(R.id.spLogCategory1) as Spinner
                    val logCategory1 = spinner.selectedItemPosition
                    if (logCategory1 == 0) {
                        mThread = Thread(runnableCode1)
                    } else {
                        mThread = Thread(runnableCode2)
                    }
                    mThread!!.start()
                }
            }

            R.id.btnSendAnalyticsLogStop -> {
                bAnalyticsSend = false
                if (mThread != null) {
                    mThread!!.interrupt()
                    mThread = null
                }
            }
        }
    }

    /**
     * #3876 일감 관련
     *
     * @param alreadyChosen
     * @return
     */
    private fun chooseCharacter(alreadyChosen: ArrayList<String>): String {

        val candidates = ArrayList<String>()

        val rawData = arrayOf("민병우", "유기정", "이가희", "조지훈", "문재호", "김윤기", "윤진영", "류명지", "최석근", "서라현")

        for (i in rawData.indices) {
            if (!alreadyChosen.contains(rawData[i])) {
                candidates.add(rawData[i])
            }
        }

        val random = Random()
        val index = random.nextInt(candidates.size)

        return candidates[index]
    }
}



