package com.hive.sample

import android.app.Activity
import android.view.View
import android.widget.ArrayAdapter
import android.widget.EditText
import android.widget.Spinner
import com.com2us.hivesdk.normal.freefull.google.global.android.common.R
import com.hive.Configuration
import com.hive.ResultAPI
import com.hive.sample.uihelper.ViewPagerBase

class ConfigurationTestView(activity: Activity, view: View, title: String) : ViewPagerBase(activity, view, title), View.OnClickListener {

    init {
        initUi()
    }

    private fun initUi() {
        createLogView(R.id.logview, R.id.btnLogDialog, R.id.btnLogClear)

        val spAdapter: ArrayAdapter<CharSequence> = ArrayAdapter(activity, android.R.layout.simple_spinner_item)
        spAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item)
        spAdapter.add("false")
        spAdapter.add("true")

        val spinner: Spinner = this.view.findViewById<View>(R.id.spForceReload) as Spinner
        spinner.adapter = spAdapter

        this.view.findViewById<View>(R.id.btnConfigGetMetaData).setOnClickListener(this)

    }

    override fun onClick(v: View) {

        when(v.id){
            R.id.btnConfigGetMetaData -> {
                // param: key
                val editText = this.view.findViewById<View>(R.id.edtKey) as EditText
                val key = editText.text.toString()

                // param: forceReload
                val spinner: Spinner = this.view.findViewById<View>(R.id.spForceReload) as Spinner
                val selectedForceReload = spinner.adapter.getItem(spinner.selectedItemPosition) as String
                val forceReload: Boolean = selectedForceReload.toBoolean()

                Configuration.getMetaData(key, forceReload, object: Configuration.GetMetaDataListener{
                    override fun onGetMetaData(result: ResultAPI, data: String) {
                        addLog("\n\n=== 메타 데이터 호출 ===\n")
                        addLog("\n\n=== Configuration.getMetaData($key, $forceReload) ===\n")
                        addLog("result: $result, data: $data\n")
                    }
                })
            }
        }
    }
}