package com.hive.sample.game

import org.json.JSONException
import org.json.JSONObject
import java.io.Serializable

open class Post : PostBoxObject, Serializable {
    override fun getPostId(): String {
        return gamePostId
    }

    override fun getMarketPid(): String {
        return "";
    }

    override fun getAssetCode(): String {
        return gameAssetCode
    }

    override fun getAssetAmount(): String {
        return gameAssetAmount.toString()
    }

    override fun getCharacterKey(): String {
        return gameCharacterKey
    }

    override fun getDate(): String {
        return dateAdded
    }

    override fun getUserMsg(): String {
        return gameUserMsg
    }


    var gamePostId: String
    var gameAssetCode: String
    var gameAssetAmount: Int = 0
    var gameUserMsg: String
    var gameCharacterKey: String
    var dateAdded: String

    var originalJson: JSONObject? = null

    constructor(postId: String, assetCode: String, assetAmount: Int, userMsg: String, characterKey: String, dateAdded: String) {
        this.gamePostId = postId
        this.gameAssetCode = assetCode
        this.gameAssetAmount = assetAmount
        this.gameUserMsg = userMsg
        this.gameCharacterKey = characterKey
        this.dateAdded = dateAdded
    }

    @Throws(JSONException::class)
    constructor(postData: JSONObject?) {

        if (postData == null)
            throw JSONException("post data is null")

        originalJson = postData

        gamePostId = postData.getString("post_id")
        gameAssetCode = postData.optString("asset_code")
        gameAssetAmount = postData.optInt("asset_amount")
        gameUserMsg = postData.optString("user_msg")
        gameCharacterKey = postData.optString("character_key")
        dateAdded = postData.optString("date_added")
    }

    override fun equals(obj: Any?): Boolean {
        if (obj is Post) {

            val input = obj as Post?

            return gamePostId == input?.gamePostId

        } else {
            return false
        }
    }

    override fun toString(): String {
        return originalJson.toString()
    }

}
