package com.hive.sample.game

import android.content.Context
import android.os.Handler
import android.os.Looper
import android.widget.Toast

import com.hive.sample.IAPTestView
import com.hive.sample.IAPV4TestView
import com.hive.sample.game.GamePostboxDialog
import com.hive.sample.game.GameUser
import com.hive.sample.game.IGameListener
import com.hive.sample.game.Response


// Only for Unity3D IAP sample
object PostBox {

    fun showPostBox(context: Context) {

        if (GameUser.isLogin) {

            Handler(Looper.getMainLooper()).post {
                val iapTestView: IAPTestView? = null
                val gamePostboxDialog = GamePostboxDialog(context, iapTestView)
                gamePostboxDialog.show()
            }

        } else {

            GameUser.login(object : IGameListener {

                override fun onGameListener(result: Boolean, response: Response?) {

                    if (result && response?.isSuccess == true) {

                        Handler(Looper.getMainLooper()).post {
//								onGameUserUiUpdate();

                            val iapTestView: IAPTestView? = null
                            val gamePostboxDialog = GamePostboxDialog(context, iapTestView)
                            gamePostboxDialog.show()
                        }
                    } else {

                        val msg = "Postbox Error : GameUser Login Failed."
                        Toast.makeText(context, msg, Toast.LENGTH_LONG).show()
                    }
                }
            })
        }
    }
}
