package com.hive.sample.game

import org.json.JSONException
import org.json.JSONObject

public class PostSubscription : PostBoxObject{
    override fun getPostId(): String {
        return "";
    }

    override fun getMarketPid(): String {
        return product_id
    }

    override fun getAssetCode(): String {
        return "구독"
    }

    override fun getCharacterKey(): String {
        return character_key
    }

    override fun getDate(): String {
        return "$start_date~\n$expire_date";
    }

    override fun getUserMsg(): String {
        return (if (market_id == 1) "Apple" else "Google") + ":" + product_id
    }

    override fun getAssetAmount() : String {
        val remainTime = expire_date_ms - System.currentTimeMillis()

        val seconds = (remainTime / 1000).toInt() % 60
        val minutes = (remainTime / 1000).toInt() / 60 % 60
        val hours = (remainTime / 1000).toInt() / 3600
        return String.format("ETA %02d:%02d:%02d", hours, minutes, seconds)
    }


    internal var product_id: String     /// 재화 코드
    internal var market_id: Int = 0      /// 구독 구매 마켓 , 1 : 애플 , 2: 구글
    internal var start_date: String     /// 구독 시작시간(KST)
    internal var start_date_ms: Long = 0 /// 구독 시작시간 unix timestamp
    internal var expire_date: String    /// 구독 만료시간(KST)
    internal var expire_date_ms: Long = 0 /// 구독 만료시간 unix timestamp
    internal var character_key: String  /// 캐릭터 키

    var originalJson: JSONObject? = null

    constructor(postData: JSONObject?) {
        if (postData == null)
            throw JSONException("post data is null")


        originalJson = postData

        product_id = postData.getString("product_id")
        market_id = postData.optInt("market_id")
        start_date = postData.getString("start_date")
        start_date_ms = postData.optLong("start_date_ms")
        expire_date = postData.optString("expire_date")
        expire_date_ms = postData.optLong("expire_date_ms")
        character_key = postData.optString("character_key")

    }
}