package com.hive.sample.game

import org.json.JSONException
import org.json.JSONObject

import android.text.TextUtils

class Response @Throws(JSONException::class)
constructor(var originalData: String) {

    var resultCode: String
    var resultMsg: String
    var resultData: JSONObject?
    var sessionToken: String
    var subscriptionStatusMsg: String
    var subscriptionStoreUrl: String

    val isSuccess: Boolean
        get() = TextUtils.equals(resultCode, "200")
    val isFailure: Boolean
        get() = !isSuccess

    init {

        if (TextUtils.isEmpty(originalData))
            throw JSONException("post data is null")

        val o = try {
            JSONObject(originalData)
        } catch (e: Exception) {
            JSONObject()
        }

        resultCode = o.optString("result_code")
        resultMsg = o.optString("result_msg")
        resultData = o.optJSONObject("result_data")
        sessionToken = o.optString("session_token")
        subscriptionStatusMsg = o.optString("subscription_status_msg")
        subscriptionStoreUrl = o.optString("subscription_store_url")
    }

    override fun toString(): String {
        return originalData
    }

}
